﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace $safeprojectname$
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        // conversion tools
        [DllImport("k8d.dll")]
        public static extern int DecToBin(int DecNumber);
        [DllImport("k8d.dll")]
        public static extern int BinToDec(int BinNumber);
        [DllImport("k8d.dll")]
        public static extern int DecToHex(int DecNumber);
        [DllImport("k8d.dll")]
        public static extern int HexToDec(int HexNumber);
        // I2C-bus initialising procedures
        [DllImport("k8d.dll")]
        public static extern void SelectI2CprinterPort(int port);
        [DllImport("k8d.dll")]
        public static extern void I2CbusNotBusy();
        // 8-bit Analogue to digital converter procedures
        [DllImport("k8d.dll")]
        public static extern int ReadADchannel(int Channel_no);
        [DllImport("k8d.dll")]
        public static extern int ReadADchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void ReadAllAD();
        // 8-bit Analogue to digital conversion procedures
        [DllImport("k8d.dll")]
        public static extern int OutputDAchannel(int Channel_no, int Data);
        [DllImport("k8d.dll")]
        public static extern int UpdateDAchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern void UpdateAllDA();
        [DllImport("k8d.dll")]
        public static extern int ClearDAchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern void ClearAllDA();
        [DllImport("k8d.dll")]
        public static extern int SetDAchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern void SetAllDA();
        // 6-bit Digital to analogue conversion procedures
        [DllImport("k8d.dll")]
        public static extern int OutputDACchannel(int Channel_no, int Data);
        [DllImport("k8d.dll")]
        public static extern int UpdateDACchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int UpdateDACchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void UpdateAllDAC();
        [DllImport("k8d.dll")]
        public static extern int ClearDACchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int ClearDACchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void ClearAllDAC();
        [DllImport("k8d.dll")]
        public static extern int SetDACchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int SetDACchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void SetAllDAC();
        // IO configuration procedures
        [DllImport("k8d.dl")]
        public static extern void ConfigAllIOasInput();
        [DllImport("k8d.dll")]
        public static extern int ConfigIOchipAsInput(int Chipno);
        [DllImport("k8d.dll")]
        public static extern int ConfigIOchannelAsInput(int Channelno);
        [DllImport("k8d.dll")]
        public static extern void ConfigAllIOasOutput();
        [DllImport("k8d.dll")]
        public static extern int ConfigIOchipAsOutput(int Chipno);
        [DllImport("k8d.dll")]
        public static extern int ConfigIOchannelAsOutput(int Channelno);
        [DllImport("k8ddll")]
        public static extern int UpdateIOdataArray(int Chipno, int Data);
        [DllImport("k8d.dll")]
        public static extern int ClearIOdataArray(int Chipno);
        [DllImport("k8d.dll")]
        public static extern int ClearIOchArray(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int SetIOchArray(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int SetIOdataArray(int Chipno);
        // Output procedures
        [DllImport("k8d.dll")]
        public static extern int IOoutput(int Chipno, int Data);
        [DllImport("k8d.dll")]
        public static extern int UpdateIOchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void UpdateAllIO();
        [DllImport("k8d.dll")]
        public static extern void ClearIOchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int ClearIOchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void ClearAllIO();
        [DllImport("k8d.dll")]
        public static extern void SetIOchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int SetIOchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void SetAllIO();
        // Input procedures
        [DllImport("k8d.dll")]
        public static extern int ReadIOchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int ReadIOchip(int chip_no);
        [DllImport("k8d.dll")]
        public static extern void ReadAllIO();
        // General procedures
        [DllImport("k8d.dll")]
        public static extern int ReadCard(int Cardno);
        [DllImport("k8d.dll")]
        public static extern void ReadAll();
        [DllImport("k8d.dll")]
        public static extern int UpdateCard(int Cardno);
        [DllImport("k8d.dll")]
        public static extern void UpdateAll();
        [DllImport("k8d.dll")]
        public static extern void Start_K8000();
        [DllImport("k8d.dll")]
        public static extern void Stop_K8000();

        // When the form loads you can open the card automaticly by selecting the portnumber and cardnumber
        private void Form1_Load(object sender, EventArgs e)
        {
            /* set cardnumber, select portnumber and update labels */
            initComponents();
        }
        // When you close the application stop the card K8000
        private void Form1_FormClosed(object sender, EventArgs e)
        {
            Stop_K8000();
        }
        // button1 = Open K8000
        private void button1_Click(object sender, EventArgs e)
        {
            SelectPort();
        }
        // select the port
        private void SelectPort()
        {
            // port 378 = if you have selected radioButton1
            if (radioButton1.Checked == true)
            {
                // select printerport 1
                SelectI2CprinterPort(1);
            }
            // port 278 = if you have selected radioButton2
            if (radioButton2.Checked == true)
            {
                // select printerport 2
                SelectI2CprinterPort(2);
            }
            // port 3BC = if you have selected radioButton3
            if (radioButton3.Checked == true)
            {
                // select printerport 0
                SelectI2CprinterPort(0);
            }
            // start the card
            Start_K8000();
            // Set the pictureboxes to 0 on all AD channels.
            pictureBox36.Height = 0;
            pictureBox37.Height = 0;
            pictureBox38.Height = 0;
            pictureBox39.Height = 0;
            pictureBox40.Height = 0;
            pictureBox41.Height = 0;
            pictureBox42.Height = 0;
            pictureBox43.Height = 0;
            pictureBox44.Height = 0;
            pictureBox45.Height = 0;
            pictureBox46.Height = 0;
            pictureBox47.Height = 0;
            pictureBox48.Height = 0;
            pictureBox49.Height = 0;
            pictureBox50.Height = 0;
            pictureBox51.Height = 0;
            // Remove the following characters /* and */ from the lines below and delete the
            // line ConfigAllIOasOutput();
            /* if you like to use all outputs as inputs from every card connected to the main board
            // configure all outputs as inputs
            ConfigAllIOasInput();
            */
            // Remove the following characters /* and */ from the lines below and delete the
            // line ConfigAllIOasOutput();
            /* if you like to use the outputs 1->8 as inputs from every card connected to the main board 
            // configure the first 8 outputs as inputs
            ConfigIOchipAsInput(0);
            ConfigIOchipAsOutput(1);
             */
            // Remove the following characters /* and */ from the lines below and delete the
            // line ConfigAllIOasOutput();
            /* if you like to use the outputs 9->16 as inputs from every card connected to the main board
            // configure the last 8 outputs as inputs
            ConfigIOchipAsOutput(0);
            ConfigIOchipAsInput(1);
            */
            // configure all outputs as outputs
            ConfigAllIOasOutput();
        }
        // button2 == Set All IO
        private void button2_Click(object sender, EventArgs e)
        {
            // Set all outputs on
            SetAllIO();
            // Select all the outputs from the checkBoxes 1->16 into the groupBox1
            checkBox1.Checked = true;
            checkBox2.Checked = true;
            checkBox3.Checked = true;
            checkBox4.Checked = true;
            checkBox5.Checked = true;
            checkBox6.Checked = true;
            checkBox7.Checked = true;
            checkBox8.Checked = true;
            checkBox9.Checked = true;
            checkBox10.Checked = true;
            checkBox11.Checked = true;
            checkBox12.Checked = true;
            checkBox13.Checked = true;
            checkBox14.Checked = true;
            checkBox15.Checked = true;
            checkBox16.Checked = true;
            // Read the cardnumber from the vScrollBar10-value
            int cardnr = vScrollBar10.Value;
            int i = (cardnr*1)+1;
            // Set IO chips on
            SetIOchip(cardnr);
            SetIOchip(i);
        }
        // button 3 = Clear All IO
        private void button3_Click(object sender, EventArgs e)
        {
            // Clear the outputs
            ClearAllIO();
            // Deselect all the outputs from the checkBoxes 1->16 into the groupBox1
            checkBox1.Checked = false;
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
            checkBox5.Checked = false;
            checkBox6.Checked = false;
            checkBox7.Checked = false;
            checkBox8.Checked = false;
            checkBox9.Checked = false;
            checkBox10.Checked = false;
            checkBox11.Checked = false;
            checkBox12.Checked = false;
            checkBox13.Checked = false;
            checkBox14.Checked = false;
            checkBox15.Checked = false;
            checkBox16.Checked = false;
        }

        // button4 = Set All DAC
        private void button4_Click(object sender, EventArgs e)
        {
            int cardnr = vScrollBar10.Value;
            // Set all the digital outputs (DAC1 -> DAC8) into the on status
            SetAllDAC();
                // Change the values of the 8 scrollBars to 0
                vScrollBar1.Value = 0;
                vScrollBar2.Value = 0;
                vScrollBar3.Value = 0;
                vScrollBar4.Value = 0;
                vScrollBar5.Value = 0;
                vScrollBar6.Value = 0;
                vScrollBar7.Value = 0;
                vScrollBar8.Value = 0;
                // Change the visible value bar of the pictureBox 18-25
                pictureBox18.Height = 0;
                pictureBox19.Height = 0;
                pictureBox20.Height = 0;
                pictureBox21.Height = 0;
                pictureBox22.Height = 0;
                pictureBox23.Height = 0;
                pictureBox24.Height = 0;
                pictureBox25.Height = 0;
                if (cardnr == 0)
                {
                    // Change the data used to reset the values.
                    pictureBox52.Width = 63;
                    pictureBox53.Width = 63;
                    pictureBox54.Width = 63;
                    pictureBox55.Width = 63;
                    pictureBox56.Width = 63;
                    pictureBox57.Width = 63;
                    pictureBox58.Width = 63;
                    pictureBox59.Width = 63;
                    label65.Text = "63";
                    label66.Text = "63";
                    label67.Text = "63";
                    label68.Text = "63";
                    label69.Text = "63";
                    label70.Text = "63";
                    label71.Text = "63";
                    label72.Text = "63";
                    checkBox67.Checked = true;
                    checkBox68.Checked = true;
                    checkBox69.Checked = true;
                    checkBox70.Checked = true;
                    checkBox71.Checked = true;
                    checkBox72.Checked = true;
                    checkBox73.Checked = true;
                    checkBox74.Checked = true;
                }
                if (cardnr == 1)
                {
                    // Change the data used to reset the values.
                    pictureBox60.Width = 63;
                    pictureBox61.Width = 63;
                    pictureBox62.Width = 63;
                    pictureBox63.Width = 63;
                    pictureBox64.Width = 63;
                    pictureBox65.Width = 63;
                    pictureBox66.Width = 63;
                    pictureBox67.Width = 63;
                    label73.Text = "63";
                    label74.Text = "63";
                    label75.Text = "63";
                    label76.Text = "63";
                    label77.Text = "63";
                    label78.Text = "63";
                    label79.Text = "63";
                    label80.Text = "63";
                    checkBox75.Checked = true;
                    checkBox76.Checked = true;
                    checkBox77.Checked = true;
                    checkBox78.Checked = true;
                    checkBox79.Checked = true;
                    checkBox80.Checked = true;
                    checkBox81.Checked = true;
                    checkBox82.Checked = true;
                }
                if (cardnr == 2)
                {
                    // Change the data used to reset the values.
                    pictureBox68.Width = 63;
                    pictureBox69.Width = 63;
                    pictureBox70.Width = 63;
                    pictureBox71.Width = 63;
                    pictureBox72.Width = 63;
                    pictureBox73.Width = 63;
                    pictureBox74.Width = 63;
                    pictureBox75.Width = 63;
                    label81.Text = "63";
                    label82.Text = "63";
                    label83.Text = "63";
                    label84.Text = "63";
                    label85.Text = "63";
                    label86.Text = "63";
                    label87.Text = "63";
                    label88.Text = "63";
                    checkBox83.Checked = true;
                    checkBox84.Checked = true;
                    checkBox85.Checked = true;
                    checkBox86.Checked = true;
                    checkBox87.Checked = true;
                    checkBox88.Checked = true;
                    checkBox89.Checked = true;
                    checkBox90.Checked = true;
                }
                if (cardnr == 3)
                {
                    // Change the data used to reset the values.
                    pictureBox76.Width = 63;
                    pictureBox77.Width = 63;
                    pictureBox78.Width = 63;
                    pictureBox79.Width = 63;
                    pictureBox80.Width = 63;
                    pictureBox81.Width = 63;
                    pictureBox82.Width = 63;
                    pictureBox83.Width = 63;
                    label89.Text = "63";
                    label90.Text = "63";
                    label91.Text = "63";
                    label92.Text = "63";
                    label93.Text = "63";
                    label94.Text = "63";
                    label95.Text = "63";
                    label96.Text = "63";
                    checkBox91.Checked = true;
                    checkBox92.Checked = true;
                    checkBox93.Checked = true;
                    checkBox94.Checked = true;
                    checkBox95.Checked = true;
                    checkBox96.Checked = true;
                    checkBox97.Checked = true;
                    checkBox98.Checked = true;
                }
        }

        // button5 = Clear All DAC
        private void button5_Click(object sender, EventArgs e)
        {
            int cardnr = vScrollBar10.Value;
            // Clear all digital outputs (DAC1 -> DAC8) or put them out
            ClearAllDAC();
            // Change the values of the 8 scrollBars to 0
            vScrollBar1.Value = 63;
            vScrollBar2.Value = 63;
            vScrollBar3.Value = 63;
            vScrollBar4.Value = 63;
            vScrollBar5.Value = 63;
            vScrollBar6.Value = 63;
            vScrollBar7.Value = 63;
            vScrollBar8.Value = 63;
            // Change the visible value bar of the pictureBox 18-25
            pictureBox18.Height = 126;
            pictureBox19.Height = 126;
            pictureBox20.Height = 126;
            pictureBox21.Height = 126;
            pictureBox22.Height = 126;
            pictureBox23.Height = 126;
            pictureBox24.Height = 126;
            pictureBox25.Height = 126;
            if (cardnr == 0)
            {
                // Change the data used to reset the values.
                pictureBox52.Width = 0;
                pictureBox53.Width = 0;
                pictureBox54.Width = 0;
                pictureBox55.Width = 0;
                pictureBox56.Width = 0;
                pictureBox57.Width = 0;
                pictureBox58.Width = 0;
                pictureBox59.Width = 0;
                label65.Text = "0";
                label66.Text = "0";
                label67.Text = "0";
                label68.Text = "0";
                label69.Text = "0";
                label70.Text = "0";
                label71.Text = "0";
                label72.Text = "0";
                checkBox67.Checked = false;
                checkBox68.Checked = false;
                checkBox69.Checked = false;
                checkBox70.Checked = false;
                checkBox71.Checked = false;
                checkBox72.Checked = false;
                checkBox73.Checked = false;
                checkBox74.Checked = false;
            }
            if (cardnr == 1)
            {
                // Change the data used to reset the values.
                pictureBox60.Width = 0;
                pictureBox61.Width = 0;
                pictureBox62.Width = 0;
                pictureBox63.Width = 0;
                pictureBox64.Width = 0;
                pictureBox65.Width = 0;
                pictureBox66.Width = 0;
                pictureBox67.Width = 0;
                label73.Text = "0";
                label74.Text = "0";
                label75.Text = "0";
                label76.Text = "0";
                label77.Text = "0";
                label78.Text = "0";
                label79.Text = "0";
                label80.Text = "0";
                checkBox75.Checked = false;
                checkBox76.Checked = false;
                checkBox77.Checked = false;
                checkBox78.Checked = false;
                checkBox79.Checked = false;
                checkBox80.Checked = false;
                checkBox81.Checked = false;
                checkBox82.Checked = false;
            }
            if (cardnr == 2)
            {
                // Change the data used to reset the values.
                pictureBox68.Width = 0;
                pictureBox69.Width = 0;
                pictureBox70.Width = 0;
                pictureBox71.Width = 0;
                pictureBox72.Width = 0;
                pictureBox73.Width = 0;
                pictureBox74.Width = 0;
                pictureBox75.Width = 0;
                label81.Text = "0";
                label82.Text = "0";
                label83.Text = "0";
                label84.Text = "0";
                label85.Text = "0";
                label86.Text = "0";
                label87.Text = "0";
                label88.Text = "0";
                checkBox83.Checked = false;
                checkBox84.Checked = false;
                checkBox85.Checked = false;
                checkBox86.Checked = false;
                checkBox87.Checked = false;
                checkBox88.Checked = false;
                checkBox89.Checked = false;
                checkBox90.Checked = false;
            }
            if (cardnr == 3)
            {
                // Change the data used to reset the values.
                pictureBox76.Width = 0;
                pictureBox77.Width = 0;
                pictureBox78.Width = 0;
                pictureBox79.Width = 0;
                pictureBox80.Width = 0;
                pictureBox81.Width = 0;
                pictureBox82.Width = 0;
                pictureBox83.Width = 0;
                label89.Text = "0";
                label90.Text = "0";
                label91.Text = "0";
                label92.Text = "0";
                label93.Text = "0";
                label94.Text = "0";
                label95.Text = "0";
                label96.Text = "0";
                checkBox91.Checked = false;
                checkBox92.Checked = false;
                checkBox93.Checked = false;
                checkBox94.Checked = false;
                checkBox95.Checked = false;
                checkBox96.Checked = false;
                checkBox97.Checked = false;
                checkBox98.Checked = false;
            }
        }

        // button6 = Set IO-chip 0
        private void button6_Click(object sender, EventArgs e)
        {
            // read cardnumber
            int cardnr = vScrollBar10.Value;
            // set IO chip on I/O 1-8.
            SetIOchip(cardnr);
            // Set the outputs from the chipnumber 0 on
            setOutputsChip0();
        }
        private void setOutputsChip0()
        {
            // Make the application visible.
            checkBox1.Checked = true;
            checkBox99.Checked = true;
            checkBox2.Checked = true;
            checkBox100.Checked = true;
            checkBox3.Checked = true;
            checkBox101.Checked = true;
            checkBox4.Checked = true;
            checkBox102.Checked = true;
            checkBox5.Checked = true;
            checkBox103.Checked = true;
            checkBox6.Checked = true;
            checkBox104.Checked = true;
            checkBox7.Checked = true;
            checkBox105.Checked = true;
            checkBox8.Checked = true;
            checkBox106.Checked = true;
        }
        private void checkOutputsChip0()
        {
            // checkBox1 = IO 1, checkBox2 = IO 2 and so on.
            if (checkBox1.Checked == true)
            {
                checkBox1.Checked = false;
            }
            else
            {
                checkBox1.Checked = true;
            }
            if (checkBox2.Checked == true)
            {
                checkBox2.Checked = false;
            }
            else
            {
                checkBox2.Checked = true;
            }
            if (checkBox3.Checked == true)
            {
                checkBox3.Checked = false;
            }
            else
            {
                checkBox3.Checked = true;
            }
            if (checkBox4.Checked == true)
            {
                checkBox4.Checked = false;
            }
            else
            {
                checkBox4.Checked = true;
            }
            if (checkBox5.Checked == true)
            {
                checkBox5.Checked = false;
            }
            else
            {
                checkBox5.Checked = true;
            }
            if (checkBox6.Checked == true)
            {
                checkBox6.Checked = false;
            }
            else
            {
                checkBox6.Checked = true;
            }
            if (checkBox7.Checked == true)
            {
                checkBox7.Checked = false;
            }
            else
            {
                checkBox7.Checked = true;
            }
            if (checkBox8.Checked == true)
            {
                checkBox8.Checked = false;
            }
            else
            {
                checkBox8.Checked = true;
            }
        }
        // button7 = Set IO-chip 1
        private void button7_Click(object sender, EventArgs e)
        {
            // Read cardnumber from the vScrollBar10
            int cardnr = vScrollBar10.Value + 1;
            // Set IO chip on
            SetIOchip(cardnr);
            // Set the outputs from chipnumber 1 on
            setOutputsChip1();
        }
        private void setOutputsChip1()
        {
            // Make the application visible.
            checkBox9.Checked = true;
            checkBox107.Checked = true;
            checkBox10.Checked = true;
            checkBox108.Checked = true;
            checkBox11.Checked = true;
            checkBox109.Checked = true;
            checkBox12.Checked = true;
            checkBox110.Checked = true;
            checkBox13.Checked = true;
            checkBox111.Checked = true;
            checkBox14.Checked = true;
            checkBox112.Checked = true;
            checkBox15.Checked = true;
            checkBox113.Checked = true;
            checkBox16.Checked = true;
            checkBox114.Checked = true;
        }
        
        private void checkOutputsChip1()
        {
            // checkBox9 = IO 9, checkBox10 = IO 10 and so on.
            if (checkBox9.Checked == true)
            {
                checkBox9.Checked = false;
            }
            else
            {
                checkBox9.Checked = true;
            }
            if (checkBox10.Checked == true)
            {
                checkBox10.Checked = false;
            }
            else
            {
                checkBox10.Checked = true;
            }
            if (checkBox11.Checked == true)
            {
                checkBox11.Checked = false;
            }
            else
            {
                checkBox11.Checked = true;
            }
            if (checkBox12.Checked == true)
            {
                checkBox12.Checked = false;
            }
            else
            {
                checkBox12.Checked = true;
            }
            if (checkBox13.Checked == true)
            {
                checkBox13.Checked = false;
            }
            else
            {
                checkBox13.Checked = true;
            }
            if (checkBox14.Checked == true)
            {
                checkBox14.Checked = false;
            }
            else
            {
                checkBox14.Checked = true;
            }
            if (checkBox15.Checked == true)
            {
                checkBox15.Checked = false;
            }
            else
            {
                checkBox15.Checked = true;
            }
            if (checkBox16.Checked == true)
            {
                checkBox16.Checked = false;
            }
            else
            {
                checkBox16.Checked = true;
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = vScrollBar10.Value;
            // Turn IO chip off
            ClearIOchip(cardnr);
            // Clear the outputs on chipnumber 0
            clearOutputsChip0();
        }

        private void clearOutputsChip0()
        {
            // Make the application visible.
            checkBox1.Checked = false ;
            checkBox99.Checked = false ;
            checkBox2.Checked = false;
            checkBox100.Checked = false;
            checkBox3.Checked = false;
            checkBox101.Checked = false;
            checkBox4.Checked = false;
            checkBox102.Checked = false;
            checkBox5.Checked = false;
            checkBox103.Checked = false;
            checkBox6.Checked = false;
            checkBox104.Checked = false;
            checkBox7.Checked = false;
            checkBox105.Checked = false;
            checkBox8.Checked = false;
            checkBox106.Checked = false;
        }
        
        private void button9_Click(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = vScrollBar10.Value + 1;
            // Turn IO chip off
            ClearIOchip(cardnr);
            // Clear the outputs on chipnumber 1
            clearOutputsChip1();

        }

        private void clearOutputsChip1()
        {
            // Make the application visible.
            checkBox9.Checked = false;
            checkBox107.Checked = false;
            checkBox10.Checked = false;
            checkBox108.Checked = false;
            checkBox11.Checked = false;
            checkBox109.Checked = false;
            checkBox12.Checked = false;
            checkBox110.Checked = false;
            checkBox13.Checked = false;
            checkBox111.Checked = false;
            checkBox14.Checked = false;
            checkBox112.Checked = false;
            checkBox15.Checked = false;
            checkBox113.Checked = false;
            checkBox16.Checked = false;
            checkBox114.Checked = false;
        }

        // button 10 = Close K8000
        private void button10_Click(object sender, EventArgs e)
        {
            /* I2CbusNotBusy(); */
            Stop_K8000();
        }

        // button11 = Read AD Channel 1
        private void button11_Click(object sender, EventArgs e)
        {
            int cardnr = vScrollBar10.Value + 1;
            int i;
            i = ReadADchannel(cardnr);
            label50.Text = i.ToString();
        }

        // button12 = Read AD Channel 2
        private void button12_Click(object sender, EventArgs e)
        {

            int cardnr = vScrollBar10.Value + 2;
            int i;
            i = ReadADchannel(cardnr);
            label51.Text = i.ToString();
        }

        // button13 = Read AD Channel 3
        private void button13_Click(object sender, EventArgs e)
        {
            int cardnr = vScrollBar10.Value + 3;
            int i;
            i = ReadADchannel(cardnr);
            label52.Text = i.ToString();
        }

        // button14 = Read AD Channel 4 
        private void button14_Click(object sender, EventArgs e)
        {
            int cardnr = vScrollBar10.Value + 4;
            int i;
            i = ReadADchannel(cardnr);
            label53.Text = i.ToString();
        }

        // button15 = Read IO-chip 0
        /* Be carefull when you change the code, the IC's will have to be configured as
           inputs, check also the IC's notch on the print before testing the program !.
           Change also the code below  Start_k8000();  */
        private void button15_Click(object sender, EventArgs e)
        {
            /* Only use the following code if you like to use IO-channels 1->8|17->24|33->40|49->56 as inputs,
              check also the IC's on the print!.
           int chipnr = vScrollBar10.Value;
           ConfigIOchipAsInput(chipnr);
           ReadIOchip(chipnr);
           label54.Text = chipnr.ToString();
            */
        }

        // button16 = Read IO-chip 1
        /* Be carefull when you change the code, the IC's will have to be configured as
          inputs, check also the IC's noch on the print before testing the program !.
          Change also the code below  Start_k8000();  */
        private void button16_Click(object sender, EventArgs e)
        {
            /* Only use the following code if you will use IO-channels 9->16/25->32/41->48/57->64 as inputs,
              depending on the cardnumber, check also the IC's on the print!.
          int chipnr2 = vScrollBar6.Value;
          ConfigIOchipAsInput(chipnr2);
          ReadIOchip(chipnr2);
          label55.Text = chipnr2.ToString();
           */
        }

        // If you like to use one or more outputs as inputs, you will have to remove the code
        // from the lines below and change them into ReadIOchannel(channelnumber)
        // checkBox1 = output 1/17/33 or 49,  checkBox2 = output 2/18/34 or 50, and so on.
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 1;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox1.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox99.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox19.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox35.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox51.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox99.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox19.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox35.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox51.Checked = false;
                }
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 2;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox2.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox100.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox20.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox36.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox52.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox100.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox20.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox36.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox52.Checked = false;
                }
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 3;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox3.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox101.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox21.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox37.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox53.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox101.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox21.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox37.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox53.Checked = false;
                }
            }
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 4;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox4.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox102.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox22.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox38.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox54.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox102.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox22.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox38.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox54.Checked = false;
                }
            }
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 5;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox5.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox103.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox23.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox39.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox55.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox103.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox23.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox39.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox55.Checked = false;
                }
            }
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 6;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox6.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox104.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox24.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox40.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox56.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox104.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox24.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox40.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox56.Checked = false;
                }
            }
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 7;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox7.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox105.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox25.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox41.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox57.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox105.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox25.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox41.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox58.Checked = false;
                }
            }
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 8;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox8.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox106.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox26.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox42.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox58.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox106.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox26.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox42.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox58.Checked = false;
                }
            }
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 9;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox9.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox107.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox27.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox43.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox59.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox107.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox27.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox43.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox59.Checked = false;
                }
            }
        }

        private void checkBox10_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 10;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox10.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox108.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox28.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox44.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox60.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox108.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox28.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox44.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox60.Checked = false;
                }
            }
        }

        private void checkBox11_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 11;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox11.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox109.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox29.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox45.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox61.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox109.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox29.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox45.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox61.Checked = false;
                }
            }
        }

        private void checkBox12_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 12;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox12.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox110.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox30.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox46.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox62.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox110.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox30.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox46.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox62.Checked = false;
                }
            }
        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 13;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox13.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox111.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox31.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox47.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox63.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox111.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox31.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox47.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox63.Checked = false;
                }
            }
        }

        private void checkBox14_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 14;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox14.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox112.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox32.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox48.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox64.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox112.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox32.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox48.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox64.Checked = false;
                }
            }
        }

        private void checkBox15_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 15;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox15.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox113.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox33.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox49.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox65.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox113.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox33.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox49.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox65.Checked = false;
                }
            }
        }

        private void checkBox16_CheckedChanged(object sender, EventArgs e)
        {
            // Read cardnumber
            int cardnr = (vScrollBar10.Value * 16) + 16;
            int kaart = vScrollBar10.Value + 1;
            if (checkBox16.Checked == true)
            {
                SetIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox114.Checked = true;
                }
                if (kaart == 2)
                {
                    checkBox34.Checked = true;
                }
                if (kaart == 3)
                {
                    checkBox50.Checked = true;
                }
                if (kaart == 4)
                {
                    checkBox66.Checked = true;
                }
            }
            else
            {
                ClearIOchannel(cardnr);
                if (kaart == 1)
                {
                    checkBox114.Checked = false;
                }
                if (kaart == 2)
                {
                    checkBox34.Checked = false;
                }
                if (kaart == 3)
                {
                    checkBox50.Checked = false;
                }
                if (kaart == 4)
                {
                    checkBox66.Checked = false;
                }
            }
        }

        // Cardnumber
        // Set the cardnumbers depending on the selection of the checkBoxes 17 and 18
        // checkBox17 = A1
        private void checkBox17_CheckedChanged(object sender, EventArgs e)
        {
          // When checkBox17 is selected cardnumber = 2 and when checkBox18 is also selected
          // the cardnumber = 3.
            if (checkBox17.Checked == true)
            {
                if (checkBox18.Checked == true)
                {
                    // Put the values on the label and on the vScrollBar10.
                    vScrollBar10.Value = 3;
                    label20.Text = "3";
                }
                else
                {
                    label20.Text = "2";
                    vScrollBar10.Value = 2;
                }
            }
            // When checkBox17 is not selected the cardnumber = 0 and when checkBox18
            // is selected the cardnumber = 1.
            if (checkBox17.Checked == false)
            {
                if (checkBox18.Checked == true)
                {
                    // Put the values on the label and on the vScrollBar10.
                    label20.Text = "1";
                    vScrollBar10.Value = 1;
                }
                else
                {
                    label20.Text = "0";
                    vScrollBar10.Value = 0;
                }
            }
            // Reset the checkBoxes.
            checkBox1.Checked = false;
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
            checkBox5.Checked = false;
            checkBox6.Checked = false;
            checkBox7.Checked = false;
            checkBox8.Checked = false;
            checkBox9.Checked = false;
            checkBox10.Checked = false;
            checkBox11.Checked = false;
            checkBox12.Checked = false;
            checkBox13.Checked = false;
            checkBox14.Checked = false;
            checkBox15.Checked = false;
            checkBox16.Checked = false;
            // Update also the text on the labels, groupBoxes and on other components.
            updateLabels();
        }

        // checkBox17 = A0
        private void checkBox18_CheckedChanged(object sender, EventArgs e)
        {
            // When checkBox18 is selected cardnumber = 1 and when checkBox17 is also selected
            // the cardnumber = 3.
            if (checkBox18.Checked == true)
            {
                if (checkBox17.Checked == true)
                {
                    label20.Text = "3";
                    vScrollBar10.Value = 3;
                }
                else
                {
                    label20.Text = "1";
                    vScrollBar10.Value = 1;
                }
            }
            if (checkBox18.Checked == false)
            {
                if (checkBox17.Checked == true)
                {
                    label20.Text = "2";
                    vScrollBar10.Value = 2;
                }
                else
                {
                    label20.Text = "0";
                    vScrollBar10.Value = 0;
                }
            }
            // Reset the checkBoxes.
            checkBox1.Checked = false;
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
            checkBox5.Checked = false;
            checkBox6.Checked = false;
            checkBox7.Checked = false;
            checkBox8.Checked = false;
            checkBox9.Checked = false;
            checkBox10.Checked = false;
            checkBox11.Checked = false;
            checkBox12.Checked = false;
            checkBox13.Checked = false;
            checkBox14.Checked = false;
            checkBox15.Checked = false;
            checkBox16.Checked = false;
            updateLabels();
        }
        private void timer3_Tick(object sender, EventArgs e)
        {
            // If you want to switch the screen every 20 seconds enable the timer in the Form1.cs[Design].
            switchCard();
        }
        private void switchCard()
        {
            int cardnr = vScrollBar10.Value;
            // Switch between the cards to update the AD channels.
            // When checkBox18 is selected cardnumber = 1 and when checkBox17 is also selected
            // the cardnumber = 3.
            // When checkBox17 is selected cardnumber = 2 and when checkBox18 is also selected
            // the cardnumber = 3.
            if (cardnr == 0)
            {
                // switch to cardn° 1;
                vScrollBar10.Value = 1;
                checkBox18.Checked = true;
            }
            if (cardnr == 1)
            {
                // switch to cardn° 2;
                vScrollBar10.Value = 2;
                checkBox18.Checked = false;
                checkBox17.Checked = true;
            }
            if (cardnr == 2)
            {
                // switch to cardn° 3;
                vScrollBar10.Value = 3;
                checkBox17.Checked = true;
                checkBox18.Checked = true;
            }
            if (cardnr == 3)
            {
                // switch to cardn° 0;
                vScrollBar10.Value = 0;
                checkBox18.Checked = false;
                checkBox17.Checked = false;
            }
            label20.Text = "" + vScrollBar10.Value;
            updateLabels();
        }
        private void updateLabels()
        {
            // Read cardnumber from the value of vScrollBar10 and use it as a number.
            int cardnr = vScrollBar10.Value;
            // Set the labels on the actual cardnumber
            // Label3 - label18 = I/O 1 - I/O 16 
            // and use it into a single-dimensional array as strings.
            string[] s2 = new string[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", "62", "63", "64" };
            String format = s2.ToString();
            int a = (cardnr * 16) + 1;
            // Update the labels: label3 -> label18 and change the text if necessary.
            label3.Text = s2[a].ToString();
            int b = (cardnr * 16) + 2;
            label4.Text = s2[b].ToString();
            int c = (cardnr * 16) + 3;
            label5.Text = s2[c].ToString();
            int d = (cardnr * 16) + 4;
            label6.Text = s2[d].ToString();
            int e = (cardnr * 16) + 5;
            label7.Text = s2[e].ToString();
            int f = (cardnr * 16) + 6;
            label8.Text = s2[f].ToString();
            int g = (cardnr * 16) + 7;
            label9.Text = s2[g].ToString();
            int h = (cardnr * 16) + 8;
            label10.Text = s2[h].ToString();
            int i = (cardnr * 16) + 9;
            label11.Text = s2[i].ToString();
            int j = (cardnr * 16) + 10;
            label12.Text = s2[j].ToString();
            int k = (cardnr * 16) + 11;
            label13.Text = s2[k].ToString();
            int l = (cardnr * 16) + 12;
            label14.Text = s2[l].ToString();
            int m = (cardnr * 16) + 13;
            label15.Text = s2[m].ToString();
            int n = (cardnr * 16) + 14;
            label16.Text = s2[n].ToString();
            int o = (cardnr * 16) + 15;
            label17.Text = s2[o].ToString();
            int p = (cardnr * 16) + 16;
            label18.Text = s2[p].ToString();
            // Update the DAC labels on the groupBoxes: groupBox11 -> groupBox18 if necesarry.
            int q = (cardnr * 8) + 1;
            groupBox11.Text = s2[q].ToString();
            int r = (cardnr * 8) + 2;
            groupBox12.Text = s2[r].ToString();
            int s = (cardnr * 8) + 3;
            groupBox13.Text = s2[s].ToString();
            int t = (cardnr * 8) + 4;
            groupBox14.Text = s2[t].ToString();
            int u = (cardnr * 8) + 5;
            groupBox15.Text = s2[u].ToString();
            int v = (cardnr * 8) + 6;
            groupBox16.Text = s2[v].ToString();
            int w = (cardnr * 8) + 7;
            groupBox17.Text = s2[w].ToString();
            int x = (cardnr * 8) + 8;
            groupBox18.Text = s2[x].ToString();
            // update DA 1 labels on groupBox19 if necesarry.
            int y = (cardnr * 1) + 1;
            groupBox19.Text = "DA " + s2[y].ToString();
            // update the labels of AD 1 -> AD 4 on the groupBoxes: groupBox7 -> groupBox10
            int z = (cardnr * 4) + 1;
            groupBox7.Text = "AD " + s2[z].ToString();
            int aa = (cardnr * 4) + 2;
            groupBox8.Text = "AD " + s2[aa].ToString();
            int ab = (cardnr * 4) + 3;
            groupBox9.Text = "AD " + s2[ab].ToString();
            int ac = (cardnr * 4) + 4;
            groupBox10.Text = "AD " + s2[ac].ToString();
            // Update labels 42->49
            /* label42.Text = "DAC" + s2[q].ToString();
            label43.Text = "DAC" + s2[r].ToString();
            label44.Text = "DAC" + s2[s].ToString();
            label45.Text = "DAC" + s2[t].ToString();
            label46.Text = "DAC" + s2[u].ToString();
            label47.Text = "DAC" + s2[v].ToString();
            label48.Text = "DAC" + s2[w].ToString();
            label49.Text = "DAC" + s2[x].ToString();
            */
            offsetCards();

        }
        private void offsetCards()
        {
            // Read cardnumber from the value of vScrollBar10 and use it as a number.
            int cardnr = vScrollBar10.Value;
            int kaart = vScrollBar10.Value + 1;
            // Reset the scrollBars and pictureBoxes for the DAC channels.
            // Reset scrollBars.
            vScrollBar1.Value = 63;
            vScrollBar2.Value = 63;
            vScrollBar3.Value = 63;
            vScrollBar4.Value = 63;
            vScrollBar5.Value = 63;
            vScrollBar6.Value = 63;
            vScrollBar7.Value = 63;
            vScrollBar8.Value = 63;
            vScrollBar9.Value = 255;
            // Reset pictureBoxes.
            pictureBox18.Height = 126;
            pictureBox19.Height = 126;
            pictureBox20.Height = 126;
            pictureBox21.Height = 126;
            pictureBox22.Height = 126;
            pictureBox23.Height = 126;
            pictureBox24.Height = 126;
            pictureBox25.Height = 126;
            pictureBox27.Height = 255;
            // Reset labels 30-38.
            label30.Text = "00";
            label31.Text = "00";
            label32.Text = "00";
            label33.Text = "00";
            label34.Text = "00";
            label35.Text = "00";
            label36.Text = "00";
            label37.Text = "00";
            label38.Text = "000";

            // Attach the values to the labels/pictureBoxes and checkBoxes.
            // Cardnumber 0.
            if (cardnr == 0)
            {
                // I/O 1->16.
                if (checkBox99.Checked == true)
                {
                    checkBox1.Checked = true;
                }
                if (checkBox100.Checked == true)
                {
                    checkBox2.Checked = true;
                }
                if (checkBox101.Checked == true)
                {
                    checkBox3.Checked = true;
                }
                if (checkBox102.Checked == true)
                {
                    checkBox4.Checked = true;
                }
                if (checkBox103.Checked == true)
                {
                    checkBox5.Checked = true;
                }
                if (checkBox104.Checked == true)
                {
                    checkBox6.Checked = true;
                }
                if (checkBox105.Checked == true)
                {
                    checkBox7.Checked = true;
                }
                if (checkBox106.Checked == true)
                {
                    checkBox8.Checked = true;
                }
                if (checkBox107.Checked == true)
                {
                    checkBox9.Checked = true;
                }
                if (checkBox108.Checked == true)
                {
                    checkBox10.Checked = true;
                }
                if (checkBox109.Checked == true)
                {
                    checkBox11.Checked = true;
                }
                if (checkBox110.Checked == true)
                {
                    checkBox12.Checked = true;
                }
                if (checkBox111.Checked == true)
                {
                    checkBox13.Checked = true;
                }
                if (checkBox112.Checked == true)
                {
                    checkBox14.Checked = true;
                }
                if (checkBox113.Checked == true)
                {
                    checkBox15.Checked = true;
                }
                if (checkBox114.Checked == true)
                {
                    checkBox16.Checked = true;
                }
                if (label99.Text != "000")
                {
                    // DA1.
                    pictureBox27.Height = 255 - pictureBox84.Height;
                    label38.Text = label99.Text;
                    vScrollBar9.Value =255- pictureBox84.Height;
                }
                if (checkBox67.Checked == true)
                {
                    // DAC1.
                    vScrollBar1.Value = pictureBox52.Width;
                    label30.Text = label65.Text;
                    pictureBox18.Height = 126 - (pictureBox52.Width * 2);
                }
                if (checkBox68.Checked == true)
                {
                    // DAC2.
                    vScrollBar2.Value = pictureBox53.Width;
                    label31.Text = label66.Text;
                    pictureBox19.Height = 126 - pictureBox53.Width * 2;
                }
                if (checkBox69.Checked == true)
                {
                    // DAC3.
                    vScrollBar3.Value = pictureBox54.Width;
                    label32.Text = label67.Text;
                    pictureBox20.Height = 126 - pictureBox54.Width * 2;
                }
                if (checkBox70.Checked == true)
                {
                    // DAC4.
                    vScrollBar4.Value = pictureBox55.Width;
                    label33.Text = label68.Text;
                    pictureBox21.Height = 126 - pictureBox55.Width * 2;
                }
                if (checkBox71.Checked == true)
                {
                    // DAC5.
                    vScrollBar5.Value = pictureBox56.Width;
                    label34.Text = label69.Text;
                    pictureBox22.Height = 126 - pictureBox56.Width * 2;
                }
                if (checkBox72.Checked == true)
                {
                    // DAC6.
                    vScrollBar6.Value = pictureBox57.Width;
                    label35.Text = label70.Text;
                    pictureBox23.Height = 126 - pictureBox57.Width * 2;
                }
                if (checkBox73.Checked == true)
                {
                    // DAC7.
                    vScrollBar7.Value = pictureBox58.Width;
                    label36.Text = label71.Text;
                    pictureBox24.Height = 126 - pictureBox58.Width * 2;
                }
                if (checkBox74.Checked == true)
                {
                    // DAC8.
                    vScrollBar8.Value = pictureBox59.Width;
                    label37.Text = label72.Text;
                    pictureBox25.Height = 126 - pictureBox59.Width * 2;
                }
            }
            // Cardnumber 1.
            if (cardnr == 1)
            {
                // I/O 17->32.
                if (checkBox19.Checked == true)
                {
                    checkBox1.Checked = true;
                }
                if (checkBox20.Checked == true)
                {
                    checkBox2.Checked = true;
                }
                if (checkBox21.Checked == true)
                {
                    checkBox3.Checked = true;
                }
                if (checkBox22.Checked == true)
                {
                    checkBox4.Checked = true;
                }
                if (checkBox23.Checked == true)
                {
                    checkBox5.Checked = true;
                }
                if (checkBox24.Checked == true)
                {
                    checkBox6.Checked = true;
                }
                if (checkBox25.Checked == true)
                {
                    checkBox7.Checked = true;
                }
                if (checkBox26.Checked == true)
                {
                    checkBox8.Checked = true;
                }
                if (checkBox27.Checked == true)
                {
                    checkBox9.Checked = true;
                }
                if (checkBox28.Checked == true)
                {
                    checkBox10.Checked = true;
                }
                if (checkBox29.Checked == true)
                {
                    checkBox11.Checked = true;
                }
                if (checkBox30.Checked == true)
                {
                    checkBox12.Checked = true;
                }
                if (checkBox31.Checked == true)
                {
                    checkBox13.Checked = true;
                }
                if (checkBox32.Checked == true)
                {
                    checkBox14.Checked = true;
                }
                if (checkBox33.Checked == true)
                {
                    checkBox15.Checked = true;
                }
                if (checkBox34.Checked == true)
                {
                    checkBox16.Checked = true;
                }
                if (label100.Text != "000")
                {
                    // DA2.
                    pictureBox27.Height = 255 - pictureBox85.Height;
                    label38.Text = label100.Text;
                    vScrollBar9.Value =255- pictureBox85.Height;
                }
                if (checkBox75.Checked == true)
                {
                    // DAC9.
                    vScrollBar1.Value = pictureBox60.Width;
                    label30.Text = label73.Text;
                    pictureBox18.Height = 126 - pictureBox60.Width * 2;
                }
                if (checkBox76.Checked == true)
                {
                    // DAC10.
                    vScrollBar2.Value = pictureBox61.Width;
                    label31.Text = label74.Text;
                    pictureBox19.Height = 126 - pictureBox61.Width * 2;
                }
                if (checkBox77.Checked == true)
                {
                    // DAC11.
                    vScrollBar3.Value = pictureBox62.Width;
                    label32.Text = label75.Text;
                    pictureBox20.Height = 126 - pictureBox62.Width * 2;
                }
                if (checkBox78.Checked == true)
                {
                    // DAC12.
                    vScrollBar4.Value = pictureBox63.Width;
                    label33.Text = label76.Text;
                    pictureBox21.Height = 126 - pictureBox63.Width * 2;
                }
                if (checkBox79.Checked == true)
                {
                    // DAC13.
                    vScrollBar5.Value = pictureBox64.Width;
                    label34.Text = label77.Text;
                    pictureBox22.Height = 126 - pictureBox64.Width * 2;
                }
                if (checkBox80.Checked == true)
                {
                    // DAC14.
                    vScrollBar6.Value = pictureBox65.Width;
                    label35.Text = label78.Text;
                    pictureBox23.Height = 126 - pictureBox65.Width * 2;
                }
                if (checkBox81.Checked == true)
                {
                    // DAC15.
                    vScrollBar7.Value = pictureBox66.Width;
                    label36.Text = label79.Text;
                    pictureBox24.Height = 126 - pictureBox66.Width * 2;
                }
                if (checkBox82.Checked == true)
                {
                    // DAC16.
                    vScrollBar8.Value = pictureBox67.Width;
                    label37.Text = label80.Text;
                    pictureBox25.Height = 126 - pictureBox67.Width * 2;
                }
            }
            // Cardnumber 2.
            if (cardnr == 2)
            {
                // I/O 33->48.
                if (checkBox35.Checked == true)
                {
                    checkBox1.Checked = true;
                }
                if (checkBox36.Checked == true)
                {
                    checkBox2.Checked = true;
                }
                if (checkBox37.Checked == true)
                {
                    checkBox3.Checked = true;
                }
                if (checkBox38.Checked == true)
                {
                    checkBox4.Checked = true;
                }
                if (checkBox39.Checked == true)
                {
                    checkBox5.Checked = true;
                }
                if (checkBox40.Checked == true)
                {
                    checkBox6.Checked = true;
                }
                if (checkBox41.Checked == true)
                {
                    checkBox7.Checked = true;
                }
                if (checkBox42.Checked == true)
                {
                    checkBox8.Checked = true;
                }
                if (checkBox43.Checked == true)
                {
                    checkBox9.Checked = true;
                }
                if (checkBox44.Checked == true)
                {
                    checkBox10.Checked = true;
                }
                if (checkBox45.Checked == true)
                {
                    checkBox11.Checked = true;
                }
                if (checkBox46.Checked == true)
                {
                    checkBox12.Checked = true;
                }
                if (checkBox47.Checked == true)
                {
                    checkBox13.Checked = true;
                }
                if (checkBox48.Checked == true)
                {
                    checkBox14.Checked = true;
                }
                if (checkBox49.Checked == true)
                {
                    checkBox15.Checked = true;
                }
                if (checkBox50.Checked == true)
                {
                    checkBox16.Checked = true;
                }
                if (label101.Text != "000")
                {
                    // DA3.
                    pictureBox27.Height = 255 - pictureBox86.Height;
                    label38.Text = label101.Text;
                    vScrollBar9.Value = 255 - pictureBox86.Height;
                }
                if (checkBox83.Checked == true)
                {
                    // DAC17.
                    vScrollBar1.Value = pictureBox68.Width;
                    label30.Text = label81.Text;
                    pictureBox18.Height = 126 - pictureBox68.Width * 2;
                }
                if (checkBox84.Checked == true)
                {
                    // DAC18.
                    vScrollBar2.Value = pictureBox69.Width;
                    label31.Text = label82.Text;
                    pictureBox19.Height = 126 - pictureBox69.Width * 2;
                }
                if (checkBox85.Checked == true)
                {
                    // DAC19.
                    vScrollBar3.Value = pictureBox70.Width;
                    label32.Text = label83.Text;
                    pictureBox20.Height = 126 - pictureBox70.Width * 2;
                }
                if (checkBox86.Checked == true)
                {
                    // DAC20.
                    vScrollBar4.Value = pictureBox71.Width;
                    label33.Text = label84.Text;
                    pictureBox21.Height = 126 - pictureBox71.Width * 2;
                }
                if (checkBox87.Checked == true)
                {
                    // DAC21.
                    vScrollBar5.Value = pictureBox72.Width;
                    label34.Text = label85.Text;
                    pictureBox22.Height = 126 - pictureBox72.Width * 2;
                }
                if (checkBox88.Checked == true)
                {
                    // DAC22.
                    vScrollBar6.Value = pictureBox73.Width;
                    label35.Text = label86.Text;
                    pictureBox23.Height = 126 - pictureBox73.Width * 2;
                }
                if (checkBox89.Checked == true)
                {
                    // DAC23.
                    vScrollBar7.Value = pictureBox74.Width;
                    label36.Text = label87.Text;
                    pictureBox24.Height = 126 - pictureBox74.Width * 2;
                }
                if (checkBox90.Checked == true)
                {
                    // DAC24.
                    vScrollBar8.Value = pictureBox75.Width;
                    label37.Text = label88.Text;
                    pictureBox25.Height = 126 - pictureBox75.Width * 2;
                }
            }
            // Cardnumber 3.
            if (cardnr == 3)
            {
                // I/O 49->64.
                if (checkBox51.Checked == true)
                {
                    checkBox1.Checked = true;
                }
                if (checkBox52.Checked == true)
                {
                    checkBox2.Checked = true;
                }
                if (checkBox53.Checked == true)
                {
                    checkBox3.Checked = true;
                }
                if (checkBox54.Checked == true)
                {
                    checkBox4.Checked = true;
                }
                if (checkBox55.Checked == true)
                {
                    checkBox5.Checked = true;
                }
                if (checkBox56.Checked == true)
                {
                    checkBox6.Checked = true;
                }
                if (checkBox57.Checked == true)
                {
                    checkBox7.Checked = true;
                }
                if (checkBox58.Checked == true)
                {
                    checkBox8.Checked = true;
                }
                if (checkBox59.Checked == true)
                {
                    checkBox9.Checked = true;
                }
                if (checkBox60.Checked == true)
                {
                    checkBox10.Checked = true;
                }
                if (checkBox61.Checked == true)
                {
                    checkBox11.Checked = true;
                }
                if (checkBox62.Checked == true)
                {
                    checkBox12.Checked = true;
                }
                if (checkBox63.Checked == true)
                {
                    checkBox13.Checked = true;
                }
                if (checkBox64.Checked == true)
                {
                    checkBox14.Checked = true;
                }
                if (checkBox65.Checked == true)
                {
                    checkBox15.Checked = true;
                }
                if (checkBox66.Checked == true)
                {
                    checkBox16.Checked = true;
                }
                if (label102.Text != "000")
                {
                    // DA4.
                    pictureBox27.Height = 255 - pictureBox87.Height;
                    label38.Text = label102.Text;
                    vScrollBar9.Value = 255 - pictureBox87.Height;
                }
                if (checkBox91.Checked == true)
                {
                    // DAC25.
                    vScrollBar1.Value = pictureBox76.Width;
                    label30.Text = label89.Text;
                    pictureBox18.Height = 126 - pictureBox76.Width * 2;
                }
                if (checkBox92.Checked == true)
                {
                    // DAC26.
                    vScrollBar2.Value = pictureBox77.Width;
                    label31.Text = label90.Text;
                    pictureBox19.Height = 126 - pictureBox77.Width * 2;
                }
                if (checkBox93.Checked == true)
                {
                    // DAC27.
                    vScrollBar3.Value = pictureBox78.Width;
                    label32.Text = label91.Text;
                    pictureBox20.Height = 126 - pictureBox78.Width * 2;
                }
                if (checkBox94.Checked == true)
                {
                    // DAC28.
                    vScrollBar4.Value = pictureBox79.Width;
                    label33.Text = label92.Text;
                    pictureBox21.Height = 126 - pictureBox79.Width * 2;
                }
                if (checkBox95.Checked == true)
                {
                    // DAC29.
                    vScrollBar5.Value = pictureBox80.Width;
                    label34.Text = label93.Text;
                    pictureBox22.Height = 126 - pictureBox80.Width * 2;
                }
                if (checkBox96.Checked == true)
                {
                    // DAC30.
                    vScrollBar6.Value = pictureBox81.Width;
                    label35.Text = label94.Text;
                    pictureBox23.Height = 126 - pictureBox81.Width * 2;
                }
                if (checkBox97.Checked == true)
                {
                    // DAC31.
                    vScrollBar7.Value = pictureBox82.Width;
                    label36.Text = label95.Text;
                    pictureBox24.Height = 126 - pictureBox82.Width * 2;
                }
                if (checkBox98.Checked == true)
                {
                    // DAC32.
                    vScrollBar8.Value = pictureBox83.Width;
                    label37.Text = label96.Text;
                    pictureBox25.Height = 126 - pictureBox83.Width * 2;
                }
            }
        }

        // radioButton1 = LPT-port 378
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            SelectPort();

        }
        // radioButton2 = LPT-port 278
        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            SelectPort();
        }
        // radioButton3 = LPT-port 3BC
        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            SelectPort();
        }

        // vScrollBar1 = scrollbar on DAC 1
        private void vScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            int output = cardnr;
            // Value of output DAC1 = 63-vScrollBar1.Value
            int count = (63 - vScrollBar1.Value);
            String _sValue = count.ToString();
            label30.Text = _sValue;
            if (cardnr == 1)
            {
                label65.Text = _sValue;
                pictureBox52.Width = count;
                if (count != 0)
                {
                    checkBox67.Checked = true;
                }
                if (count == 0)
                {
                    checkBox67.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label73.Text = _sValue;
                pictureBox60.Width = count;
                if (count != 0)
                {
                    checkBox75.Checked = true;
                }
                if (count == 0)
                {
                    checkBox75.Checked = false;
                }
            }
            if (cardnr ==3)
            {
                label81.Text = _sValue;
                pictureBox68.Width = count;
                if (count != 0)
                {
                    checkBox83.Checked = true;
                }
                if (count == 0)
                {
                    checkBox83.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label89.Text = _sValue;
                pictureBox76.Width = count;
                if (count != 0)
                {
                    checkBox91.Checked = true;
                }
                if (count == 0)
                {
                    checkBox91.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox18.Height = 126-(count * 2);
            // Attach the value to the output DAC1
            OutputDACchannel(output , count);
        }
        // vScrollBar2 = scrollbar on DAC 2
        private void vScrollBar2_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            int output = cardnr + 1;
            // Value of output DAC2 = 63-vScrollBar2.Value
            int count = (63 - vScrollBar2.Value);
            String _sValue = count.ToString();
            label31.Text = _sValue;
            if (cardnr == 1)
            {
                label66.Text = _sValue;
                pictureBox53.Width = count;
                if (count != 0)
                {
                    checkBox68.Checked = true;
                }
                if (count == 0)
                {
                    checkBox68.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label74.Text = _sValue;
                pictureBox61.Width = count;
                if (count != 0)
                {
                    checkBox76.Checked = true;
                }
                if (count == 0)
                {
                    checkBox76.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label82.Text = _sValue;
                pictureBox69.Width = count;
                if (count != 0)
                {
                    checkBox84.Checked = true;
                }
                if (count == 0)
                {
                    checkBox84.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label90.Text = _sValue;
                pictureBox77.Width = count;
                if (count != 0)
                {
                    checkBox92.Checked = true;
                }
                if (count == 0)
                {
                    checkBox92.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox19.Height = 126 - (count * 2);
            // Attach the value to the output DAC2
            OutputDACchannel(output , count);
        }
        // vScrollBar3 = scrollBar on output DAC3
        private void vScrollBar3_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            int output = cardnr + 2;
            // Value of output DAC3 = 63-vScrollBar3.Value
            int count = (63 - vScrollBar3.Value);
            String _sValue = count.ToString();
            label32.Text = _sValue;
            if (cardnr == 1)
            {
                label67.Text = _sValue;
                pictureBox54.Width = count;
                if (count != 0)
                {
                    checkBox69.Checked = true;
                }
                if (count == 0)
                {
                    checkBox69.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label75.Text = _sValue;
                pictureBox62.Width = count;
                if (count != 0)
                {
                    checkBox77.Checked = true;
                }
                if (count == 0)
                {
                    checkBox77.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label83.Text = _sValue;
                pictureBox70.Width = count;
                if (count != 0)
                {
                    checkBox85.Checked = true;
                }
                if (count == 0)
                {
                    checkBox85.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label91.Text = _sValue;
                pictureBox78.Width = count;
                if (count != 0)
                {
                    checkBox93.Checked = true;
                }
                if (count == 0)
                {
                    checkBox93.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox20.Height = 126 - (count * 2);
            // Attach the value on the output DAC3
            OutputDACchannel(output , count);
        }
        // vScrollBar4 = scrollBar on output DAC4
        private void vScrollBar4_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            int output = cardnr + 3;
            // Value of output DAC4 = 63-vScrollBar4.Value
            int count = (63 - vScrollBar4.Value);
            String _sValue = count.ToString();
            label33.Text = _sValue;
            if (cardnr == 1)
            {
                label68.Text = _sValue;
                pictureBox55.Width = count;
                if (count != 0)
                {
                    checkBox70.Checked = true;
                }
                if (count == 0)
                {
                    checkBox70.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label76.Text = _sValue;
                pictureBox64.Width = count;
                if (count != 0)
                {
                    checkBox78.Checked = true;
                }
                if (count == 0)
                {
                    checkBox78.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label84.Text = _sValue;
                pictureBox72.Width = count;
                if (count != 0)
                {
                    checkBox86.Checked = true;
                }
                if (count == 0)
                {
                    checkBox86.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label92.Text = _sValue;
                pictureBox79.Width = count;
                if (count != 0)
                {
                    checkBox94.Checked = true;
                }
                if (count == 0)
                {
                    checkBox94.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox21.Height = 126 - (count * 2);
            // Attach the value on the output DAC4
            OutputDACchannel(output , count);
        }
        // vScrollBar5 = scrollBar on output DAC5
        private void vScrollBar5_Scroll_1(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            int output = cardnr + 4;
            // Value of output DAC5 = 63-vScrollBar5.Value
            int count = (63 - vScrollBar5.Value);
            String _sValue = count.ToString();
            label34.Text = _sValue;
            if (cardnr == 1)
            {
                label69.Text = _sValue;
                pictureBox56.Width = count;
                if (count != 0)
                {
                    checkBox71.Checked = true;
                }
                if (count == 0)
                {
                    checkBox71.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label77.Text = _sValue;
                pictureBox64.Width = count;
                if (count != 0)
                {
                    checkBox79.Checked = true;
                }
                if (count == 0)
                {
                    checkBox79.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label85.Text = _sValue;
                pictureBox72.Width = count;
                if (count != 0)
                {
                    checkBox87.Checked = true;
                }
                if (count == 0)
                {
                    checkBox87.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label93.Text = _sValue;
                pictureBox80.Width = count;
                if (count != 0)
                {
                    checkBox95.Checked = true;
                }
                if (count == 0)
                {
                    checkBox95.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox22.Height = 126 - (count * 2);
            // Attach the value on the output DAC5
            OutputDACchannel(output , count);
        }
        // vScrollBar6 = scrollBar on output DAC6
       private void vScrollBar6_Scroll(object sender, ScrollEventArgs e)
        {

            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
           int output = cardnr +5;
            // Value of output DAC6 = 63-vScrollBar6.Value
            int count = (63 - vScrollBar6.Value);
            String _sValue = count.ToString();
            label35.Text = _sValue;
            if (cardnr == 1)
            {
                label70.Text = _sValue;
                pictureBox57.Width = count;
                if (count != 0)
                {
                    checkBox72.Checked = true;
                }
                if (count == 0)
                {
                    checkBox72.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label78.Text = _sValue;
                pictureBox65.Width = count;
                if (count != 0)
                {
                    checkBox80.Checked = true;
                }
                if (count == 0)
                {
                    checkBox80.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label86.Text = _sValue;
                pictureBox73.Width = count;
                if (count != 0)
                {
                    checkBox88.Checked = true;
                }
                if (count == 0)
                {
                    checkBox88.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label94.Text = _sValue;
                pictureBox81.Width = count;
                if (count != 0)
                {
                    checkBox96.Checked = true;
                }
                if (count == 0)
                {
                    checkBox96.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox23.Height = 126 - (count * 2);
            // Attach the value on the output DAC6
            OutputDACchannel(output , count);
        }
        // vScrollBar7 = scrollBar on output DAC7
        private void vScrollBar7_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            // Value of output DAC7 = 63-vScrollBar7.Value
            int count = (63 - vScrollBar7.Value);
            int output = cardnr + 6;
            String _sValue = count.ToString();
            label36.Text = _sValue;
            if (cardnr == 1)
            {
                label71.Text = _sValue;
                pictureBox58.Width = count;
                if (count != 0)
                {
                    checkBox73.Checked = true;
                }
                if (count == 0)
                {
                    checkBox73.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label79.Text = _sValue;
                pictureBox66.Width = count;
                if (count != 0)
                {
                    checkBox81.Checked = true;
                }
                if (count == 0)
                {
                    checkBox81.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label87.Text = _sValue;
                pictureBox74.Width = count;
                if (count != 0)
                {
                    checkBox89.Checked = true;
                }
                if (count == 0)
                {
                    checkBox89.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label95.Text = _sValue;
                pictureBox82.Width = count;
                if (count != 0)
                {
                    checkBox97.Checked = true;
                }
                if (count == 0)
                {
                    checkBox97.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox24.Height = 126 - (count * 2);
            // Attach the value on the output DAC7
            OutputDACchannel(output , count);
        }
        // vScrollBar8 = scrollBar on output DAC8
        private void vScrollBar8_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            int output = cardnr + 7;
            // Value of output DAC8 = 63-vScrollBar8.Value
            int count = (63 - vScrollBar8.Value);
            String _sValue = count.ToString();
            label37.Text = _sValue;
            if (cardnr == 1)
            {
                label72.Text = _sValue;
                pictureBox59.Width = count;
                if (count != 0)
                {
                    checkBox74.Checked = true;
                }
                if (count == 0)
                {
                    checkBox74.Checked = false;
                }
            }
            if (cardnr == 2)
            {
                label80.Text = _sValue;
                pictureBox67.Width = count;
                if (count != 0)
                {
                    checkBox82.Checked = true;
                }
                if (count == 0)
                {
                    checkBox82.Checked = false;
                }
            }
            if (cardnr == 3)
            {
                label88.Text = _sValue;
                pictureBox75.Width = count;
                if (count != 0)
                {
                    checkBox90.Checked = true;
                }
                if (count == 0)
                {
                    checkBox90.Checked = false;
                }
            }
            if (cardnr == 4)
            {
                label96.Text = _sValue;
                pictureBox83.Width = count;
                if (count != 0)
                {
                    checkBox98.Checked = true;
                }
                if (count == 0)
                {
                    checkBox98.Checked = false;
                }
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 126 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 63.
            // Use a variable _nHeight to determine the height.
            pictureBox25.Height = 126 - (count * 2);
            // Attach the value on the output DAC8
            OutputDACchannel(output , count);
        }

        // vScrollBar9 = scrollBar on digital precision output DA1.
        private void vScrollBar9_Scroll(object sender, ScrollEventArgs e)
        {
            // Read the cardnumber.
            int cardnr = vScrollBar10.Value + 1;
            // Value of output DA1 = 255-vScrollBar9.Value
            int count = (255 - vScrollBar9.Value);
            String _sValue = count.ToString();
            label38.Text = _sValue;
            if (cardnr == 1)
            {
                label99.Text = _sValue;
                pictureBox84.Height = count;
            }
            if (cardnr == 2)
            {
                label100.Text = _sValue;
                pictureBox85.Height = count;
            }
            if (cardnr == 3)
            {
                label101.Text = _sValue;
                pictureBox86.Height = count;
            }
            if (cardnr == 4)
            {
                label102.Text = _sValue;
                pictureBox87.Height = count;
            }
            // Set the height of the visible value of the bar next to the scrollbar.
            // Maximum height = 255 when the value of the scrollbar = 0.
            // Minimum height = 0 when the value of the scrollbar = 255.
            // Use a variable _nHeight to determine the height.
            pictureBox27.Height = 255 - count;
            // Attach the value on the output DA1 conforming to the cardnumber.
            OutputDAchannel(cardnr, count);
        }

        // Interval of timer2 = 2 seconds so every 2 seconds the interval will be reset.
        // Use the interval to update the digital inputs AD 1 -> AD 4
        private void timer2_Tick(object sender, EventArgs e)
        {
            textBox2.Text = "No warnings...";
            // Update the AD channels.
            updateADchannels();
        }
        private void updateADchannels()
        {
            textBox2.Text = "No warnings...";
            // Read the cardnumber and paste a value to the variables a->d.
            int a = (vScrollBar10.Value * 4) + 1;
            int b = (vScrollBar10.Value * 4) + 2;
            int c = (vScrollBar10.Value * 4) + 3;
            int d = (vScrollBar10.Value * 4) + 4;
            // Add a variable for each value returned by reading the channels.
            int valueOfAD1 = ReadADchannel(a);
            int valueOfAD2 = ReadADchannel(b);
            int valueOfAD3 = ReadADchannel(c);
            int valueOfAD4 = ReadADchannel(d);
            // Update the 16 inputs.
            /* If you like to write your own code for more then 1 card, please remove this line and the
             * line at the end of the */
            /*
            int inputNum = 16;
            for (var i = 1; i < inputNum; i++)
            {
                ReadADchannel(i);
                // Update the corresponding pictureBoxes.
                // Set the height of the pictureboxes according the values of the AD channels.
                if (i == 1)
                {
                    pictureBox36.Height = ReadADchannel(1);
                }
                if (i == 2)
                {
                    pictureBox37.Height = ReadADchannel(2);
                }
                if (i == 3)
                {
                    pictureBox38.Height = ReadADchannel(3);
                }
                if (i == 4)
                {
                    pictureBox39.Height = ReadADchannel(4);
                }
                if (i == 5)
                {
                    pictureBox40.Height = ReadADchannel(5);
                }
                if (i == 6)
                {
                    pictureBox41.Height = ReadADchannel(6);
                }
                if (i == 7)
                {
                    pictureBox42.Height = ReadADchannel(7);
                }
                if (i == 8)
                {
                    pictureBox43.Height = ReadADchannel(8);
                }
                if (i == 9)
                {
                    pictureBox44.Height = ReadADchannel(9);
                }
                if (i == 10)
                {
                    pictureBox45.Height = ReadADchannel(10);
                }
                if (i == 11)
                {
                    pictureBox46.Height = ReadADchannel(11);
                }
                if (i == 12)
                {
                    pictureBox47.Height = ReadADchannel(12);
                }
                if (i == 13)
                {
                    pictureBox48.Height = ReadADchannel(13);
                }
                if (i == 14)
                {
                    pictureBox49.Height = ReadADchannel(14);
                }
                if (i == 15)
                {
                    pictureBox50.Height = ReadADchannel(15);
                }
                if (i == 16)
                {
                    pictureBox51.Height = ReadADchannel(16);
                }
            }
             */
            // When the value is not equal to 0, the following script will be executed.
            // We use the K8067 temperature sensor for the following script.
            // Read out AD1.
            if (valueOfAD1 != 0)
            {
                // Next code comes here.
                /* If you want to use the code below, remove this line and the following characters:/* */
                /*  
                // Make warnings for the channel AD1
                // 0°C = 0V or 1.153V = 37°C, the maximum of the temperature sensor is 70°C, so the value is 255.
                // Only from 0°C -> 37°C we can be sure so 255/3.642 = 70.
                // When the temperature is less than 46 as value it is too cold.
                if(valueOfAD1<=46){
                    // Warning when the temperature <12.6°C or 46 as value on the AD channel 1.
                    // Use an output on which you connect an alarm or a buzzer for example on output 1.
                    SetIOchannel(1);
                    textBox2.Text = "The temperature is falling.\r"+"\n! Check inverters !";
                }
                if(valueOfAD1<=43){
                    // The temperature has fallen down to the critical point of 11.8°C.
                    // Use an output on which you connect an alarm for example on output 1.
                    SetIOchannel(1);
                    // So enter an alarm to the textbox.
                    textBox2.Text = "!!! Alarm !!!\r\nThe temperature is critacaly low!.\r"+"\! Check inverters immediatly !.";
                }
                // When the temperature rises over a value of 90, it is too warm, so make a warning and an alarm.
                if(valueOfAD1>=91){
                    // Warning when the temperature is >= 25°C or 90 as a value.
                    // Use an output on which you connect an alarm for example output 1.
                    SetIOchannel(1);
                    textBox2.Text = "The temperature is rising\r"+"\nCheck ventilation!.";
                }
                // When the temperature has rised up to or over 30°C it is too warm, so set the alarm.
                if(valueOfAD1>109){
                    // Alarm status.
                    // Use an output on which you connect an alarm for example output 1.
                    SetIOchannel(1);
                    textBox2.Text = "!!! Alarm !!!!\r\nThe temperature is criticaly high !\r"+"\nCheck ventilators and ventilation immediatly!.";
                }
                */
                decimal temp = 3.64m;
                decimal temper1 = (valueOfAD1 / temp);
                label26.Text = "" + temper1;
            }
            else
            {
                // When the value of AD1 == 0 or something else.
                // In use with the K8067 temperature sensor.
                label26.Text = valueOfAD1.ToString();
                /* If you like to use the code below, remove this line and the following characters: /* */
                /*
                // The supply voltage has fallen out, throw an error.
                textBox2.Text = "!!! An error has occured on channel AD" + a + ".\r\nSensor error !!!.\r" + "\nCheck the supply voltage on the kitn° K8067.";
                // Use an output for the alarm for example on output 1 you connect an alarm or a buzzer of 12VDC.
                SetIOchannel(1);
                */
            }
            // Add the value of the AD1 channel to the pictureBox2.
            pictureBox2.Height = 255 - (valueOfAD1);

            // Read out AD2.
            if (valueOfAD2 != 0)
            {
                // In use with the K8067 temperature sensor.
                label27.Text = valueOfAD2.ToString();
            }
            else
            {
                label27.Text = valueOfAD2.ToString();
                /* If you like to use the following code, remove this line and the following characters below this line: /* */
                /*
                textBox2.Text = "!!! An error has occured on channel AD"+b+".\r\nSensor error !!!.\r"+"\nCheck the supply voltage on the kitn° K8067 or the sensor !!!.";
                // Use an output for the alarm for example on output 1 you connect an alarm or a buzzer of 12VDC.
                SetIOchannel(1);
                 */
            }
            // Add the value to the pictureBox4 on the AD2 channel.
            pictureBox4.Height = 255 - (valueOfAD2);
            // Connect a supply voltage of 3V to the input AD3.
            // Readout as a value starting at 0 and rising up to 255.

            // Read out AD3.
            if (valueOfAD3 != 0)
            {
                // Next code comes here. 
            }
            else
            {
                // Make warnings if the voltage supply has fallen out.
                /* Remove this line (if you like to use the code) and the following characters below this line: /* */
                /*
                textBox2.Text = "The value of AD" + c + " is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD" + c + ".\r\nThe supply voltage has fallen out !!!.";
                */
            }
            // Add the value into label28.
            label28.Text = valueOfAD3.ToString();
            // Add the corresponding value to the pictureBox6 on the AD3 channel.
            pictureBox6.Height = 255 - (valueOfAD3);
            // Connect a supply voltage of 3V to the input AD4.
            // Read and remember the highest value.
            // Use the highest value to set the value for example +- 245 as highest value.

            // Read out AD4.
            if (valueOfAD4 != 0)
            {
                decimal _dValue = 244.9m;
                decimal voltage = (3 * (_dValue / valueOfAD4));
                label29.Text = voltage.ToString();
            }
            else
            {
                label29.Text = valueOfAD4.ToString();
                // Make the error message.
                // Use the code below and remove the characters: /* */
                /*
                textBox2.Text = "The value of AD" + d + " is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD" + d + ".\r\nThe supply voltage has fallen out !!!.";
                */
            }
            // Add the value to the pictureBox8 on AD4.
            pictureBox8.Height = 255 - (valueOfAD4);
            // If you use more than 1 card and more than 4 inputs you have to check for errors on the other nputs also.
            /* use following script in use when inputs used > 4.
             if(pictureBox36.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD1 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD1.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox40.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD2 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD2.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox44.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD3 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD3.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox48.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD4 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD4.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox37.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD5 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD5.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox41.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD6 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD6.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox45.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD7 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD7.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox49.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD8 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD8.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox38.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD9 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD9.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox42.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD10 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD10.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox46.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD11 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD11.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox50.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD12 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD12.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox39.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD13 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD13.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox43.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD14 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD14.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox47.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD15 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD15.\r\nThe supply voltage has fallen out !!!.";
             }
              if(pictureBox51.Height == 0)
             {
             // Make errors.
             textBox2.Text = "The value of AD16 is zero, please check the supply voltage.\r" + "\n!!! An error has occured on channel AD16.\r\nThe supply voltage has fallen out !!!.";
             }
             */
            // New code will be entered here.
            // Paste the code generated by the program helper here.

            // Update the errors every 2 seconds.
            CheckErrors();
        }
        private void CheckErrors()
        {
            if (textBox2.Text == "No warnings...")
            {
                groupBox24.Text = "Running...";
                groupBox24.ForeColor = System.Drawing.Color.Navy;
                // Make the warning image invisible.
                pictureBox9.Visible = false;
            }
            else
            {
                // Make the warning image visible.
                pictureBox9.Visible = true;
                groupBox24.Text = "Warning!...";
                groupBox24.ForeColor = System.Drawing.Color.Red;
            }
            // Next code comes here.
            // Run the main program.
            StartProgram();
        }
        private void initComponents()
        {
            // Initialize components and set the corresponding values for the first time use.
            // Set the values on the bars of the DAC channels to 63 and on the AD channel to 255. 
            pictureBox18.Height = 126;
            pictureBox19.Height = 126;
            pictureBox20.Height = 126;
            pictureBox21.Height = 126;
            pictureBox22.Height = 126;
            pictureBox23.Height = 126;
            pictureBox24.Height = 126;
            pictureBox25.Height = 126;
            pictureBox27.Height = 255;
        }

        // Every 500 milliseconds the following script will be executed.
        private void timer1_Tick(object sender, EventArgs e)
        {
            // Get the date and time for the current moment, adjusted to the local time zone.
            String timeStr = "" + DateTime.Now;
            textBox1.Text = timeStr;
            DateTime dt = DateTime.Now;
            String[] format = {
                // d returns: month/day/fullyear eg: 12/30/2010
                // D returns: weekday calendarday monthname year eg:Thursday 30 December 2010
                // f returns: D+ hour:mintes eg:Thursday 30 December 2010 19:56
                // F returns: f+ seconds eg: Thursday 30 December 2010 19:56:25
                // g returns: d + hour:minutes eg: 12/30/2010 19:56
                // G returns: g + seconds eg: 12/30/2010 19:56:27
                // m returns: monthname/calendarday eg: December30
                // mm returns: minutes eg: 56
                // r returns for example Thu, 30 Dec 2010 19:56:27 GMT
                // s returns for example 2010-12-30T19:56:27
                // ss returns the seconds eg: 27
                // t returns: hours:minutes eg: 19:56
                // tt returns AM or PM
                // T returns: hour:minutes:seconds
                // U returns UTC time for example Thursday,30December2010 18:56:27
                // y returns: year and monthname eg: 2010 December
                // yyyy returns: year eg: 2010
                // ddd returns the first 3 characters of the dayname eg: Thu
                // MMMM returns the full monthname eg: December
                // MMM returns the first 3 characters of the monthname eg: Dec
           "HH:mm:ss"
        };
            String date;
            int i = 0;
            date = dt.ToString(format[i], System.Globalization.DateTimeFormatInfo.InvariantInfo);
            textBox1.Text = String.Concat(date);
            String dayName = "dddd";
            String dayNameStr = dt.ToString(dayName, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            String dayStr = "ddd";
            String dayWeekStr = dt.ToString(dayStr, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label1.Text = dayWeekStr.ToString();
            if (dayWeekStr == "Sun")
            {
                // Next code comes here.
                pictureBox32.Height = 0;
                label64.Text = "0";
            }
            if (dayWeekStr == "Mon")
            {
                // Next code comes here.
                pictureBox32.Height = 10;
                label64.Text = "1";
            }
            if (dayWeekStr == "Tue")
            {
                // Next code comes here.
                pictureBox32.Height = 20;
                label64.Text = "2";
            }
            if (dayWeekStr == "Wed")
            {
                // Next code comes here.
                pictureBox32.Height = 30;
                label64.Text = "3";
            }
            if (dayWeekStr == "Thu")
            {
                // Next code comes here.
                pictureBox32.Height = 40;
                label64.Text = "4";
            }
            if (dayWeekStr == "Fri")
            {
                // Next code comes here.
                pictureBox32.Height = 50;
                label64.Text = "5";
            }
            if (dayWeekStr == "Sat")
            {
                // Next code comes here.
                pictureBox32.Height = 60;
                label64.Text = "6";
            }
            // Convert the seconds to a number to set the height of a pictureBox28.
            String seconds = "ss";
            String secStr = dt.ToString(seconds, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label57.Text = secStr.ToString();
            int s = dt.Second;
            pictureBox35.Height = 60 - s;
            // Convert the minutes to a number to set the height of a pictureBox29.
            String minutes = "mm";
            String minStr = dt.ToString(minutes, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label56.Text = minStr.ToString();            
            int m = dt.Minute;
            pictureBox34.Height = 60 - m;            
            // Convert the hours to a number to set the height of the pictureBox33.
            String hours = "HH";
            String hourStr = dt.ToString(hours, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label2.Text = hourStr;
            int h = dt.Hour;
            vScrollBar11.Value = h;
            pictureBox33.Height = 60 - ((60 / 24) * h);
        }

        private void StartProgram()
        {
            int cardnr = vScrollBar10.Value + 1;
            // The main code will be entered and descriped here.
            // Example 1: set output 2 every day on at 19:00 for 1 minute.
            // Example 2: set output 3 every sunday on at 19:00 during 5 minutes.
            // The days are disposed into label 1.
            // The hours are disposed into label 2.
            // The minutes are disposed into label 56.
            // The seconds are disposed into label 57.
            /* For example 1 we start at 19:00 */
            // Read the hours from label2.
            if (label2.Text == "22")
            {
                // Get the minutes at label56 if label56 == 0 -> Start application to run.
                if (label56.Text == "00")
                {
                    // Set the output on
                    SetIOchannel(2);
                    // Make the start of the application visible.
                    if (cardnr == 1)
                    {
                        checkBox2.Checked = true;
                    }
                    checkBox100.Checked = true;
                    // Start also the application if it is sunday for the example n° 2.
                    if (label1.Text == "Sun")
                    {
                        // Start the example n° 2 to run.
                        SetIOchannel(3);
                        // Make it visible.
                        if (cardnr == 1)
                        {
                            checkBox3.Checked = true;
                        }
                        checkBox101.Checked = true;
                    }
                }
                /* Stop the application for example n° 1 at 19:01.*/
                if (label56.Text == "01")
                {
                    // Stop example 1.
                    ClearIOchannel(2);
                    // Make it visible.
                    if (cardnr == 1)
                    {
                        checkBox2.Checked = false;
                    }
                    checkBox100.Checked = false;
                }
                /* Stop the second application at 19:05 */
                if (label56.Text == "05")
                {
                    /* Stop only at Sunday */
                    if (label1.Text == "Sun")
                    {
                        // Stop example 2.
                        ClearIOchannel(3);
                        // Make it visible.
                        if (cardnr == 1)
                        {
                            checkBox3.Checked = false;
                        }
                        checkBox101.Checked = false;
                    }
                }
            }
            // For example set output 4 on at wednesday 18:30 during 35 seconds.
            /* Get the hours from label2 */
            if (label2.Text == "18")
            {
                /* Get the minutes at label56 */
                if (label56.Text == "30")
                {
                    /* Get the day at label1 */
                    if (label1.Text == "Wed")
                    {
                        // Start the application to run.
                        SetIOchannel(4);
                        // Make the application visible.
                        if (cardnr == 1)
                        {
                            checkBox4.Checked = true;
                        }
                        checkBox102.Checked = true;
                        // after 35 seconds stop the application to run. 
                        /* You can do this in 2 different ways */
                        /* Or you get the seconds from the label57 or you can read it from
                         * the pictureBox35: 35 seconds == pictureBox35.height=60 - 35 seconds --> 25 */
                        /*if (label57.Text == "35")
                        {
                            ClearIOchannel(4);
                             if (cardnr == 1)
                        {
                            checkBox4.Checked = false;
                        }
                            checkBox102.Checked = false;
                        }*/
                        // We go for the second way because it will run for a longer time, 
                        // so the application will be more secure.
                        if (pictureBox35.Height <= 25)
                        {
                            // Stop the application to run.
                            ClearIOchannel(4);
                            // Make the application stop visible.
                            if (cardnr == 1)
                            {
                                checkBox4.Checked = false;
                            }
                            checkBox102.Checked = false;
                        }
                    }
                }
            }
            // Next code comes here.
        }
  // New function:
    }
}
